<?xml version="1.0" encoding="UTF-8" ?>
<xsl:stylesheet
    xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
    version="1.0">
    <xsl:output method="html" encoding="UTF-8" indent="yes" />
    
    <xsl:template match="Library">
        <html>
            <body>
                <h1>Library <xsl:value-of select="@title" /></h1>
                <xsl:apply-templates select="." mode="index" />
                <xsl:apply-templates select="." mode="table" />
            </body>
        </html>
    </xsl:template>
    
    <xsl:template match="Library" mode="index">
        <ul>
            <xsl:apply-templates mode="index" />
        </ul>
    </xsl:template>

    <xsl:template match="Book" mode="index">
        <li>
            <xsl:value-of select="@title" />
            <ol>
                <xsl:apply-templates mode="index" />
            </ol>
        </li>
    </xsl:template>
    
    <xsl:template match="Part" mode="index">
        <li>
            <strong><xsl:value-of select="@title" /></strong>
            <ol>
                <xsl:apply-templates mode="index" />
            </ol>
        </li>
    </xsl:template>
    
    <xsl:template match="Chapter" mode="index">
        <li>
            <xsl:value-of select="@title" />:
            <em><xsl:value-of select="." /></em>
        </li>
    </xsl:template>
    
    
    <xsl:template match="Library" mode="table">
        <table border="1">
            <tr>
                <th>Book number</th>
                <th>Book title</th>
                <th>Part number</th>
                <th>Part title</th>
                <th>Chapter number</th>
                <th>Chapter title</th>
                <th>Chapter content</th>
            </tr>
            <xsl:apply-templates select=".//Chapter" mode="table" />
        </table>
    </xsl:template>

    <xsl:template match="Chapter" mode="table">
        <tr>
            <td><xsl:value-of select="count(ancestor::Book[1]/preceding-sibling::Book) + 1" /></td>
            <td><xsl:value-of select="ancestor::Book[1]/@title" /></td>
            <td>
                <xsl:if test="ancestor::Part[1]">
                    <xsl:value-of select="count(ancestor::Part[1]/preceding-sibling::Part) + 1" />
                </xsl:if>
            </td>
            <td><xsl:value-of select="ancestor::Part[1]/@title" /></td>
            <td><xsl:value-of select="count(preceding-sibling::Chapter) + 1" /></td>
            <td><xsl:value-of select="@title" /></td>
            <td><xsl:value-of select="." /></td>
        </tr>
    </xsl:template>

</xsl:stylesheet>







