<?xml version="1.0" encoding="UTF-8" ?>
<xsl:stylesheet
    xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
    version="1.0">
    <xsl:output method="html" encoding="UTF-8" indent="yes" />

    <xsl:template match="Library">
        <html>
            <body>
                <h1>Library <xsl:value-of select="@title" /></h1>
                <table border="1">
                    <tr>
                        <th>Book number</th>
                        <th>Book title</th>
                        <th>Part number</th>
                        <th>Part title</th>
                        <th>Chapter number</th>
                        <th>Chapter title</th>
                        <th>Chapter content</th>
                    </tr>
                    <xsl:apply-templates select=".//Chapter" />
                </table>
            </body>
        </html>
    </xsl:template>
    
    <xsl:template match="Chapter">
        <tr>
            <td><xsl:value-of select="count(ancestor::Book[1]/preceding-sibling::Book) + 1" /></td>
            <td><xsl:value-of select="ancestor::Book[1]/@title" /></td>
            <td><xsl:apply-templates select="ancestor::Part[1]" /></td>
            <td><xsl:value-of select="ancestor::Part[1]/@title" /></td>
            <td><xsl:value-of select="count(preceding-sibling::Chapter) + 1" /></td>
            <td><xsl:value-of select="@title" /></td>
            <td><xsl:value-of select="." /></td>
        </tr>
    </xsl:template>
    
    <xsl:template match="Part">
        <xsl:value-of select="count(preceding-sibling::Part) + 1" />
    </xsl:template>

</xsl:stylesheet>

